unit LSTUnit;

{
   Jose Ismel Snchez Ordiana 1994.
      Reg march 2005, Version (1.1).

   Keep up the original authors list and a reference to the original
   download source of this library: jisanchez.com // dev.petalus.net

   La finalidad de esta versin reducida de la unidad, es ofrecer herramientas
   sencillas de trabajo en listas y de servir de ejemplo/plantilla en el modelado
   de un motor de listas.
                                                                        }


INTERFACE
 Uses CRT,nodosmem;{Mostrar por pantalla, eliminese con los procedimientos [*]
               una vez depurado el programa que use esta unidad.}

 Type    Index = Pointer;       {Variables para indices de listas o elementos}
 Type    Mlist = ^MlistD;       {Variable que es una lista}
         SList = ^SListStack;   {Una pila de sublistas}
         MListD = record        {Declaramos tipo de elementos de MasterList}
             DataList: Pointer; {Puntero a una zona que se reservara para datos o a la sublista}
             Size:LongInt;      {Tamao del tomo (Puede restaurarse con pchar(C Str) aadiEndo un #0}
             Atom:boolean; {Eval:boolean;} {Es un tomo?, Es evaluable?}
             ListLink:Mlist;    {Puntero al siguiente elemento de Mlist}
             ListMLink:Mlist    {Puntero al elemento anterior de la MasterList?}
             End;               {Si es el 1element, l'anterior apunta l'ultim}
         SListStack = record    {Pila para sublistas}
             BackList: Pointer;
             ListMLink: SList
             end;
{
   El rollo es que va todo el programa en una lista maestra o masterlist
  formada solo por tomos.
  Ojo, les marques d'avaluaci aix com qualsevol altra marca que es decideixca incloure
  al tipus MLISTD, haur de ser convenientment tractada en els procediments que hi ha a sota,
  a banda del tractament que li doneu. }

{PRIMITIVAS}
Procedure DestroyList;export;   {Da de baja la Masterlist, Libera la memoria e inicializa}
Function  Count:LongInt;export; {Cuantos elementos tiene la lista?)}

{[*]}
{Deben de extraerse fuera, a un include para depuracion..., o comentarse}
Procedure ShowList;export; {Muestra la MasterList por pantalla...De cualquier tamao}
Procedure ShowAtom (P:Pointer); export; {Muestra un tomo por pantalla}
{[*]}

Function  AtomToStr (P:Pointer):String;export; {Copia solo los 255 Ultimos caracteres del tomo}
Function  AtomToChar (P:Pointer;position:Longint):char;export; {Devuelve cualquier caracter de un tomo...}
Procedure ChangeACharOnAtom (P:Pointer;position:Longint;ch:char);export; {Cambia un caracter}
Function  GetFW (P:Pointer):Pointer;export; {Puntero al elemento de lista siguiente}
Function  GetRW (P:Pointer):Pointer;export; {Puntero al elemento de lista anterior}
Function  GetFirst:Pointer;export;     {Puntero Primer elemento de la Lista}
Function  GetLast:Pointer;export;              {Puntero al ltimo elemento de la Lista}
Procedure InsertaStr (cadena:String;magic:byte);export; {Insertar elemento en lista}
Procedure InsertaFile (FileName:String);export; {Inserta un archivo a la lista como tomo}
Procedure SaveFile (Filename:String;p:Pointer);export;    {Salva un tomo como un archivo}
Function  Nth(i:LongInt):Pointer;export; {Puntero al elemento numero n de la lista}

{Programades al vaporatori}
Function  GetAtomSize (P:Pointer):Longint;export; {Logitud en bytes de un atomo}
Function  GetAtomMemPos (P:Pointer):Longint;export; {Posicion en memoria de los datos del atomo}
Function  GetAtomMemPoint (P:Pointer):Pointer;export; {Puntero a los datos del atomo}
Procedure InsertaMirror (P:Pointer);export; {Genera un elemento espejo a otro (En realidad es el mismo) }
Function  IsAtom(p:Pointer):Boolean;export;

Procedure ElimElement (p:pointer);export;{Elimina la referencia a un elemento en la lista!!!}
Procedure Dettach (P:Pointer);export;   {Eliminar Un Atomo de la lista.}
Procedure InsertaCopy (P:Pointer);export; {Genera un nevo elemento igual a otro que esta en la lista}
Procedure MoveInL (Src1,Trg1:Pointer);export; {Mueve un atomo por la lista}
Procedure ExChange (Src1,Trg1:Pointer);export; {Intercambia dos elementos de la lista}
Function  InsertaHack (Entetee:Pointer;PreSized:longint;Atomic:Boolean):Pointer;export; {Insertar elemento en lista}

{SubList Procedures, programed at Tiristor's Zone}
Procedure PushL;export; {HiperList Stacking}
Procedure PopL;export;  {Push/Pop navegacion dentro de la sublista}
Procedure NewList {(evaluable:Boolean)};export;{Genera una sublista vacia en la ML}
Procedure SubList (p:Pointer);export;         {La ML es una sublista de la ML}
Procedure ClearList (p:Pointer);export;       {Limpia de atomos una lista terminal}
Procedure Removelist (p:Pointer);export;      {Elimina una sublista terminal}
Procedure AttachList (SubLst:Pointer);export; {Inserta un indice-lista a la ML!}
Procedure SetMList (nlist:mlist);export;      {Establecer una ML del usuario!, cuidado con la pole!}
Procedure SetSPole (otherstack:Slist);export; {Establecer otra pila de sublistas}
Function  PoleIndex:pointer;export;	       {Devuelve un indice a la pila actual}

{The Save/Restore procedures, at the SEDE}
Procedure SaveList (filename:String);export;
Procedure LoadList (FileName:String;ListIndex:LongInt);export;

function equalatoms (atm1,atm2:pointer):boolean;export;
Function LessAtom (Atm1,atm2:Pointer):Boolean;export;
Function GreaterAtom (Atm1,atm2:Pointer):Boolean;export;

IMPLEMENTATION


Var Primero:Mlist; {Primero Es la MasterList!!!!}
    Pole : SList;

Procedure initlist; Begin
Primero:=Nil;
End; {Bunker anticuelgues inicio}

Procedure DestroyList;           {Da de baja toda la MasterList y la reinicia}
var Siguiente:MList;  {Diriase que hay que invertir la secuencia...}
Begin
  while primero<>nil do begin
   siguiente:=primero^.Listlink;
   freemem (primero^.DataList,Siguiente^.Size);
   dispose (primero);
   primero:=siguiente;
   end;
End;


Function Count:LongInt;           {Cuenta los elementos de la MasterList}
var i:LongInt; Temp:MList;
Begin
Temp:=primero;i:=0;
While Temp<>Nil do Begin {Quiza mejor Temp^.ListLink, para sublistas...}
Temp:=Temp^.ListLink;
Inc (i);
End;
Count:=i;
End;



Procedure ShowAtom (P:Pointer); {Muestra un Atomo de la lista por pantalla}
var I:LongInt;Temp:MList;
Begin
   Temp:=P;
   if temp^.Atom then begin
   For i:=1 to Temp^.Size do Begin
       Write (chr(gMem(i-1+LongInt(temp^.DataList))));
   End;WriteLN;            end else writeln ('[err] ShowAtom: Es una sublista!');
End;

Function AtomToStr (P:Pointer):string; {Copia solo los 255 Ultimos caracteres del tomo}
var J,I:LongInt;Temp:MList;STemp:string;
Begin
Temp:=P; i:=Temp^.Size;if i>254 then j:=I-254 else j:=0;STemp:='';
   repeat Begin
    STemp:=Chr(gMem(i-1+LongInt(Temp^.DataList)))+STemp;dec(i);
   End until (I=J); {errd:Mal condicionado!!! Hasta Size-255!!!}
   AtomToStr:=STemp;
End;




{Devuelve cualquier caracter de un tomo...}
Function AtomToChar (P:Pointer;position:Longint):char;
var temp:MList;
Begin
  Temp:=p;
{  If position<temp^.Size Then } {Vamos a saco, que esos errores pueden ser aprovechados}
  AtomToChar:=chr(gMEM(position-1+LongInt(Temp^.DataList)));
End;



{Cambia un caracter de un tomo}
Procedure ChangeACharOnAtom (P:Pointer;position:Longint;ch:char);
var temp:MList;
Begin
  Temp:=p;
{  If position<temp^.Size Then } {Vamos a saco, que esos errores pueden ser aprovechados}
  ppmem(position-1+LongInt(Temp^.DataList),ord (ch));
End;

Function GetFW (P:Pointer):Pointer; {Puntero al elemento siguiente de la lista}
 var P2:Pointer;Temp:MList; Begin Temp:=P;
 p2:=p;
 If (Temp^.ListLink)<> Nil Then p2:=Temp^.ListLink;
 GetFW:=p2;
 End;


Function Nth(i:Longint):Pointer; {Puntero al elemento numero n de la lista}
 var tempoint:pointer;buc:LongInt;
 Begin
 Tempoint:=Primero;
 For buc:=2 to i do tempoint:=GetFw(Tempoint);
 Nth:=Tempoint;
 End;


Function GetRW (P:Pointer):Pointer; {Puntero al elemento anterior de lista}
var Temp:MList; Begin Temp:=P; GetRw:=Temp^.ListMLink; End; {Warning:it's Ciclic}

Function GetFirst:Pointer;     {Puntero Primer elemento de la Lista}
Begin GetFirst:=Primero; End;

Function GetLast:Pointer;              {Puntero al ltimo elemento de la Lista}
Begin GetLast:=Primero^.ListMLink; End;


{Hacking functions}
Function GetAtomSize (P:Pointer):Longint; {Logitud en bytes de un atomo}
Var temp:Mlist;
Begin Temp:=P;GetAtomSize:=Temp^.Size; End;

Function GetAtomMemPos (P:Pointer):Longint; {Posicion en memoria de los datos del atomo}
Var Temp:Mlist; {Para usar con la funcion MEM[...] ...}
Begin Temp:=p;GetAtomMemPos:=LongInt(Temp^.DataList); End;

Function GetAtomMemPoint (P:Pointer):Pointer; {Puntero a los datos del atomo}
Var Temp:Mlist; {Bienvenido al Birguery club}
Begin Temp:=p;GetAtomMemPoint:=(Temp^.DataList); End;


{Es commutativo}   {Intercambia posicion de atomos o listas en la masterlist}
Procedure ExChange (Src1,Trg1:Pointer); {Intercambia dos elementos de la lista}
Var Sour,Targ:MList;
DataList:Pointer;Size:LongInt;Atomic:Boolean;
Begin
Sour:=Src1; Targ:=trg1; {Atencion errores?... Primero:=Ultimo. No existencia...}
DataList:=Targ^.DataList;Size:=Targ^.Size; {Swap Vable}
Atomic:=Targ^.Atom;
Targ^.DataList:=Sour^.DataList;  Targ^.Size:=Sour^.Size; {Swap data atoms...}
Targ^.Atom:=Sour^.Atom;
Sour^.DataList:=DataList;        Sour^.Size:=Size;
Sour^.Atom:=Atomic;
End;


{WARNING: MoveInL es una funcion antisimetrica respecto el intercambio
La lista quedar:Atommove (src1,trg1);Exchange(src1,trg1);Atommove (src1,Trg1);}
{Tambien puede mover Listas}
Procedure MoveInL (Src1,Trg1:Pointer);
Var Sour,aux,Targ:MList;
DataList:Pointer;Size:LongInt;ListMLink,ListLink:Pointer;
Atomic:Boolean;
Begin
Sour:=Src1; Targ:=trg1; {VaBle Setup}
if Sour=Primero then exit; {El Movimiento del primero se hace con Exchange}
Aux:=Sour^.ListMLink;            {Encadenamos el anterior con el siguiente}
Aux^.ListLink:=Sour^.ListLink;

DataList:=Targ^.DataList;Size:=Targ^.Size; {Swap Vable}
ListLink:=Targ^.ListLink;ListMLink:=Targ^.ListMLink;
Atomic:=Targ^.Atom;

Targ^.DataList:=Sour^.DataList; Targ^.Size:=Sour^.Size;Targ^.Atom:=Sour^.Atom;
Sour^.DataList:=DataList;Sour^.Size:=Size;Sour^.Atom:=Atomic;

targ^.ListLink:=Sour;    {Setup Links: Warning: No son inversos... Faltaria un Exchange(src,targ)?}
Sour^.ListMLink:=Targ;
Sour^.ListLink:=ListLink;
End;


Procedure DettachAux (P:Pointer;remove:Boolean);   {Eliminar Un Atomo de la lista.}
Var  utemp,utemp2:MList;
TempPoint:Pointer;
Begin
UTemp:=P;
If Primero<>Nil Then Begin
  If Utemp=Primero Then Begin          {Primer elemento de lista}
  If Primero^.ListLink<>Nil Then Begin {Nos aseguramos que no sea de un elemento solo la lista}
  UTemp2:=UTemp^.ListLink; UTemp2^.ListMLink:=GetLast; {Eliminar Primer Elemento}
  Primero:=UTemp2;End; { Seteamos el segundo elemento como el primero}
                       End Else Begin
  If Utemp=GetLast Then Begin          {Ultimo elemento de lista}
  If Primero^.ListLink<>Nil Then Begin
  Utemp2:=UTemp^.ListMLink;
  Primero^.ListMLink:=Utemp2;
  UTemp2^.ListLink:=Nil;
  End;
                       End Else Begin   {Elemento Intermedio en lista}
  UTemp2:=UTemp^.ListMLink; {-1 forward=+1}   {Eliminar elemento intermedio...}
  UTemp2^.ListLink:=UTemp^.ListLink;
  TempPoint:=UTemp2; {+1 Rewind = -1}
  UTemp2:=UTemp^.ListLink;
  UTemp2^.ListMLink:=TempPoint;
                       End; End;
  if remove then begin
  FreeMem (uTemp^.DataList,uTemp^.Size);
  uTemp^.DataList:=Nil;uTemp^.ListLink:=Nil;uTemp^.ListMLink:=Nil; {ReMoveMe}
  Dispose (uTemp);    end;
  End;
End;

Procedure Dettach (p:pointer); {Elimina un elemento de la lista y lo borra de memoria}
begin dettachAux(p,true); end;
Procedure ElimElement (p:pointer);{Elimina la referencia a un elemento en la lista!!!}
begin dettachAux(p,false);end;



{Procedimientos para insertar elementos en la masterlist!}

Procedure InsertaMirror (P:Pointer); {Genera un elemento espejo a otro (En realidad es el mismo) }
var Elemento:MList;Aux:MList;
 begin
  if primero<>nil then begin
   New (Elemento);
   Aux:=P; {Hacemos el Mirror}
   Elemento^.Size:=Aux^.Size; Elemento^.DataList:=Aux^.DataList;
   Aux:=Primero^.ListMLink; {Enlazemos la lista}
   elemento^.Atom:=Aux^.Atom; {Sublist related}
   Elemento^.ListMLink:=Aux;
   Aux^.ListLink:=Elemento;
   Primero^.ListMLink:=Elemento;
  end;
  end;

Procedure InsertaCopy (P:Pointer); {De un Atomo}
Var Temp,Temp2:MList;Elemento:MList;I:LongInt;
Begin
If primero<>Nil Then Begin
 Temp:=P;
 New (Elemento);Elemento^.ListMLink:=GetLast;
 temp2:=Elemento^.ListMLink;temp2^.ListLink:=Elemento;
 Primero^.ListMLink:=Elemento;
 Elemento^.Size:=Temp^.Size; Elemento^.Atom:=True;
 GetMem (P,Temp^.Size);
 For i:=1 to Temp^.Size do
  ppmem(LongInt(Longint(P)+I-1),gmem(LongInt(Temp^.DataList)+I-1));
 Elemento^.DataList:=P;
 End;
End;



{ Procedimientos para insertar tomos en la lista. }

 Procedure AttachStr_aux (s:string;var nodo:Mlist);
 Var i:LongInt;p:pointer;
 Begin
  GetMem (p,length(s)); {Reservamos memoria para el tomo}
  For i:=1 To length(s) Do ppMem (i-1+LongInt(p),ord(s[i])); {Lo metemos en la ML}
  Nodo^.Size:=Length(S); nodo^.DataList:=p; Nodo^.ListLink:=Nil; {Actualizamos Vables}
  Nodo^.Atom:=True;
  End;

 Procedure InsertaStr (cadena:String;magic:byte); {Insertar elemento en lista}
 Var Elemento,Anterior,Siguiente:MList;
 Begin
{  If maxavail<length(cadena) Then Begin WriteLN ('Memory overflow!');exit;End;
}
  New (elemento);AttachStr_aux (cadena,elemento);
  Anterior:=primero;Siguiente:=Primero;
  While (Siguiente<>Nil) do {Bsqueda del ltimo tomo (Mhh:Usar ListMLink}
   Begin Anterior:=Siguiente;Siguiente:=Siguiente^.listLink;End;
  If primero=Nil Then Begin primero:=elemento;
                           primero^.ListMLink:=Primero;
                           End
  Else Begin {GeneraciOn de la lista Semicircular}
        anterior^.listlink:=elemento; {Enlazamos el ultimo con el anterior}
        Primero^.ListMLink:=elemento; {Marcamos el ultimo en el primero.}
        Elemento^.ListMLink:=anterior; {JOOOODER Si ha costao!!!!}
     End;
 End;

 Function InsertaHack (Entetee:Pointer;PreSized:longint;Atomic:Boolean):Pointer; {Insertar elemento en lista}
 Var Elemento,Anterior,Siguiente:MList;
 Begin
{  If maxavail<PreSized Then Begin WriteLN ('Memory overflow!');exit;End;
 }
 New (elemento);
 ELEMENTO^.Size:=presized; Elemento^.DataList:=entetee;
 Elemento^.Atom:=Atomic;
 Elemento^.ListLink:=Nil; {Actualizamos Vables}
 Anterior:=primero;Siguiente:=Primero;
 While (Siguiente<>Nil) do {Bsqueda del Ultimo tomo (Mhh:Usar ListMLink!!!}
 Begin Anterior:=Siguiente;Siguiente:=Siguiente^.listLink;End;
 If primero=Nil Then Begin primero:=elemento;
                           primero^.ListMLink:=Primero;
                           End
 Else Begin {Generacion de la lista Semicircular}
        anterior^.listlink:=elemento; {Enlazamos el ultimo con el anterior}
        Primero^.ListMLink:=elemento; {Marcamos el ultimo en el primero.}
        Elemento^.ListMLink:=anterior; {JOOOODER Si ha costao!!!!}
     End;
   InsertaHack:=Elemento;
 End;


 Procedure InsertaFile (FileName:String); {Lee un fichero y lo mete en un tomo}
 Var  Fin : File;
     NumRead : Word;
     Buf : Array[1..2048] of byte;
     Total,Partial : Longint;P:Pointer;
     Elemento,Aux:MList;
 Begin
   {Generamos un nuevo elemento y lo enlazamos}
      New (Elemento);

   Assign (Fin, FileName);
   {$I-}
   Reset (Fin,1);
   {$I+}
   If IOResult=0 Then Begin
{     If maxavail<filesize(Fin) Then Begin
     WriteLN ('Memory Overflow'); exit End Else
 }
     getMem (p,filesize(Fin));
     Total:=0;
     Repeat
       BlockRead (Fin,buf,Sizeof(buf),NumRead);
       For partial:=1 to Numread do
         ppMem(LongInt(p)+Total+Partial-1,ord(buf[partial]));
       inc(Total,NumRead);
   Until (NumRead=0) ;
     Elemento^.Size:=Total;Elemento^.DataList:=P;
     close(fin);
   End Else
    AttachStr_Aux ('Nil',Elemento); {El fichero no existe o err... NIL!!!}
   {Enlazamos la lista}
   Elemento^.Atom:=True;
  If Primero=Nil Then Begin
   Elemento^.ListLink:=Nil; Primero:=Elemento; Primero^.ListMLink:=Primero;
  End Else Begin
   Aux:=Primero^.ListMLink;  {Aux es ahora el ultimo tomo}
   Elemento^.ListMLink:=Aux; {El enlace anterior del elemento definido apunta al antiguo ultimo}
   Aux^.ListLink:=Elemento;  {El enlace anterior del antiguo ultimo apunta al nuevo elemento}
   primero^.ListMLink:=Elemento; {El ultimo es el nuevo}
  End
  End;

 Procedure SaveFile (Filename:String;p:Pointer);{Salva un tomo como un archivo}
  Var fout : File;                {Que tipo de test de errores devolvemos?}
     NumWritten : Word;
     Buf : Array[1..1] of byte;
     Total : Longint;Temp:MList;
 Begin
   Assign (Fout,FileName);Temp:=p;
   {$I-}
   ReWrite (Fout,1);
   {$I+}
   If ioresult=0 Then Begin
   Total:=0;
   For total:=1 to temp^.Size do Begin
   buf[1]:=gMem(LongInt(Temp^.DataList)+total-1);
   BlockWrite (Fout,Buf,1,NumWritten);
   End;
   close (fout);
   End Else Begin
   {$I-}
   ReWrite (Fout,1);
   {$I+}
   End;

 End;

 Function IsAtom (P:Pointer):Boolean;
  Var Temp:MList;
  Begin
  temp:=p;
  IsAtom:=Temp^.Atom;
  End;

 procedure PushL;
 var SubList:SList;
 begin
 New (SubList);
 SubList^.ListMLink:=Pole;
 SubList^.BackList:=Primero;
 Pole:=SubList;
 End;

 Procedure PopL;
 Var AUX:SLIST;
 Begin
 If Pole=Nil Then WriteLN ('[err] Pop on toplevel') else begin
 AUX:=POLE^.listMLink;
 Primero:=Pole^.BackList;
 Dispose (Pole);
 Pole:=Aux;
 End;
 End;

 Procedure SetMList (nlist:mlist); {Establecer otra lista como la maestra}
 Begin
 Primero:=nlist;
 End;

 Procedure SetSPole (otherstack:Slist); {Establecer otra pila de sublistas}
 Begin
 pole:=otherstack;
 End;

 Function PoleIndex:pointer; {Devuelve un indice a la pila actual}
 Begin
 poleindex:=pole;
 End;

 Procedure NewList {(evaluable:Boolean)};
 Var sublist,Temp:MList;
 Begin
 New (Temp);TEMP^.ATOM:=TRUE;Temp^.DataList:=Nil;
 SubList:=InsertaHack (Temp,0,false); {Seria interesante mantener el concepto de atomos de longitud 0?}
 {PushLNow?}
 end;

 Procedure AttachList (SubLst:Pointer); {Inserta un indice-lista a la ML!}
 Var Temp:MList;SubList:MList;
 Begin
 New (Temp);TEMP^.ATOM:=TRUE;Temp^.DataList:=Nil;
 SubList:=InsertaHack (Temp,0,False); {Seria interesante mantener el concepto de atomos de longitud 0?}
 Temp^.ListLink:=SubLst;
 End;

 Procedure SubList (p:Pointer);
 Var temp2,temp,SubList:MList;
 Begin     {No es el mtodo que mas ahorra, pero es menos penoso al programar usando esta unidad}
  SubList:=P;
  Temp:=SubList^.DataList;
  temp2:=temp;
  If temp2^.ListLink<>Nil Then Begin
                 Temp2:=Temp2^.ListLink;
                 Primero:=temp2; {Primero^.ListMLink:=nil;}
                End Else Begin
                 primero:=Temp2;
                 If primero^.ListLink=Nil Then Primero^.ListMLink:=Nil;
                End;
 End;


 Procedure ClearList (p:Pointer);
 Var temp,temp2:Mlist;
 Begin
 Pushl;
 SubList (p);
 DestroyList;
 popl;
 Temp2:=p;
 New (temp);
 Temp^.Atom:=True;Temp^.DataList:=Nil;
 Temp2^.DataList:=temp;
 End;

 Procedure Removelist (p:Pointer);
 Begin
 PushL;
 SubList (p);
 DestroyList;
 PopL;
 Dettach(p);
 End;

 Procedure ShowList; {Muestra la MasterList por pantalla...De cualquier tamao}
 Var siguiente:Mlist;i:LongInt;
 Begin
 Siguiente:=Primero;
 Textcolor (15);write ('(');Textcolor (7);
 While (Siguiente<>Nil) do
Begin
   If siguiente^.Size+2+wherex>79 Then WriteLN;
   {Aqu va el filtro para detectar la insercion en sublistas
    para poder mostrarlas por pantalla en formato (...(...)...) }
    If siguiente^.Atom Then Begin
       Write ('`');
         For i:=1 To Siguiente^.Size Do Begin
          Write (chr(gMem(i-1+LongInt(siguiente^.DataList))));
          End;
       Write (#39); End Else

          Begin{SubListing}
           PushL;
           SubList (Siguiente);
           ShowList;
           PopL;
           End;
   siguiente:=Siguiente^.ListLink;
   If siguiente<>Nil then write (' ');end;
  If wherex=76 then writeln;
  TextColor (15);write (')');TextColor (7);
   If primero=Nil Then Write ('NIL');
End;


procedure SaveList (filename:String);
Var fout:file;
     NumWritten : Word;
     Buf : Array[1..1] of byte;

     Function IntToStr (I : Longint) : String;
         Var S : String;
          begin
            Str (I,S);
            IntToStr:=S;
          end;

     Procedure SavingList (Inil:Mlist);
        Var temp:MList;total:LongInt;s:String;
        Begin
        temp:=Inil;
        While temp<>Nil Do Begin
        If temp^.atom Then
           Begin
              buf[1]:=1; {1=Atomo}   BlockWrite (Fout,Buf,1,NumWritten);
              {ahora la Longitud}
              s:=inttostr(temp^.size);
              For total:=1 To length(s) Do Begin
                             buf[1]:=ord(s[total]);
                             BlockWrite (Fout,Buf,1,NumWritten);
                             End;
                             Buf[1]:=0;{final de longitud}BlockWrite (Fout,Buf,1,NumWritten);

           {Escribe los datos del atomo}
              Total:=0;
                 For total:=1 To temp^.Size Do Begin
                 buf[1]:=(gMem(LongInt(Temp^.DataList)+total-1));
                 BlockWrite (Fout,Buf,1,NumWritten);
             End;

           End
           {Escribe atomo,longitud y datos}
           Else Begin
                buf[1]:=0; {0=Inicio de lista} BlockWrite (Fout,Buf,1,NumWritten);
   {             Write ('(');}
                PushL;
                SubList(Temp);

                SavingList (primero);
                PopL;
{                Write (')');}
                buf[1]:=2; {2=final de lista}BlockWrite (Fout,Buf,1,NumWritten);
                End;
        temp:=temp^.ListLink;
        End;
{        WriteLN ;}
        End;

Begin
Assign (fout,filename);
{$i-}
ReWrite (fout,1);
{$i+}
If IOResult=0 Then Begin
SavingList (primero);
        buf[1]:=3;BlockWrite (Fout,Buf,1,NumWritten); {Fin de registro de lista}
Close (fout);
End Else Begin
        {$i-}
        ReWrite (fout,1);
        {$i+}
        End;

End; {Of SavingList}
{Descripcion del archivo:
   identificador,datafield ; Donde el identificador dice si es lista o atomo.
identificador 0,2:=Inicio/Fin de lista.
Identificador 1   =Es un atomo, despues va su longitud seguido de un cero al
cual le siguen todos datos asociados al atomo. Nota: Para Salvado, todos
los mirrors se salvan como atomos libres!!!!
4=El siguiente elemento es evaluable
6=Es un elemento stream a un UAM
3=Final del grupo de registro para esta lista

}


Procedure LoadList (FileName:String;ListIndex:LongInt);
 Var  Fin : File;
     NumRead : Word;
     Buf : Array[1..2048] of byte; {y uno se pregunta, porque 2048?, seguro que es un ao de buena cosecha...}
	ndx:longint;

  Procedure Ince;
        Begin
        Inc (ndx);
        If ndx>2048 Then Begin  BlockRead (Fin,buf,Sizeof(buf),NumRead);
        ndx:=1;
        End;
        End;

  Function StrToInt (S:String):LongInt;
  Var I:Longint;c:Word;
  Begin
   Val (S,I,C);
   StrToInT:=i;
  End;


 Procedure ReadAtom;
  Var s:String;p:Pointer;incre,counter:Longint;
   Begin
    s:='';ince;
    While buf[ndx]<>0 do Begin s:=s+chr(buf[ndx]);ince;End;
    counter:=strtoint(s);Getmem (p,counter);incre:=0;
    If counter>0 Then Begin
         Dec (Counter);
           Repeat
           Begin ince;ppMem(LongInt(p)+incre,buf[ndx]);Inc (incre);End;
           Until incre>counter;
         Inc (counter);
         End;       {Hay que diferencia entre lista vacia o atomo vacio?,creo que no...}
    If counter=0 then {insertahack (nil,0,true)}begin end else
    InsertaHack (p,counter,True);
  End;




 Procedure Loadlst;
 Begin
  ndx:=1;  BlockRead (Fin,buf,Sizeof(buf),NumRead);
  while (Buf[ndx]<>3) Do Begin
   if Buf[NDX]=1 Then Begin ReadAtom; inc (ndx); End Else
   if buf[ndx]=0 Then Begin PUSHL; NEWLIST;SUBLIST (GETLAST);Inc (ndx);END else
   IF BUF[NDX]=2 Then Begin PopL; Inc (Ndx) End Else
   Begin WriteLN ('Tipo de nodo desconocido... error de versin?');exit;end;
  End;
  If ndx>2048 Then Begin
   BlockRead (Fin,buf,Sizeof(buf),NumRead);
   ndx:=1;
  End;
 End;

Begin
If ListIndex<>0 Then Begin
   WriteLN ('Este programa requiere Hiper/Master List V1.4');
   halt (8);
   End;
Assign (Fin,Filename);
{$i-}
Reset (fin,1);
{$i+}
{Busqueda de la lista almacenada nmero 'ListIndex'}
If IoResult=0 Then Begin
Loadlst;
Close (Fin); End Else Begin
        WriteLN ('Lista no encontrada...'); {Debug, deleteme}
        {$i-} {Now generate the error again, ioresult>0 again}
        Reset(Fin,1);
        {$i+}
        End;
End;

Function EqualAtoms (atm1,atm2:Pointer):Boolean;
Var salda:Boolean;tmp1,tmp2:MList;buc,u:LongInt;
Begin
tmp1:=atm1;tmp2:=atm2;
salda:=True;
If tmp1^.Size<>tmp2^.Size Then Salda:=False Else
 Begin
  buc:=tmp2^.Size;u:=0;
  Repeat inc (u)
  Until ((gMem(LongInt(Tmp1^.DataList)+u-1)<>gMem(LongInt(Tmp2^.DataList)+u-1))
      Or (u=buc));
 If u<>buc Then Salda:=False;
 End;
 Equalatoms:=Salda;
End;

Function GreaterAtom (Atm1,atm2:Pointer):Boolean;
Var Salda:Boolean;tmp1,tmp2:MList;size,u:LongInt;
Begin
tmp1:=atm1;tmp2:=atm2;
 size:=tmp1^.size; {Get the min of two atoms size}
 salda:=False; {Asumimos la hiptesis nula.}
 If tmp2^.size<>size Then Begin
    If size>tmp2^.size Then salda:=True End Else
    Begin
    {size:=tmp2^.size;}
 u:=0;
 Repeat
  Begin
  Inc (u);
  If (gMem(LongInt(Tmp1^.DataList)+u-1)>gMem(LongInt(Tmp2^.DataList)+u-1)) Then
    salda:= True;
    End;
  Until ( (salda) Or (u=size));
 If ((not salda) And (u=size)) Then If tmp1^.size>tmp2^.size Then salda:=True;
 End;
 If size=0 Then Begin
    If tmp2^.Size=0 Then salda:=True;
    If tmp1^.Size=0 Then salda:=False;
    End;
 GreaterAtom:=salda;
End;

Function LessAtom (Atm1,Atm2:Pointer):Boolean;
Begin
 LessAtom:=GreaterAtom (Atm2,Atm1);
{ LessAtom:=NOT GreaterAtom (Atm1,Atm2); Para eliminar lo del infinito...
  pero la hipotesis nula cambiaria ahora... pero como no hay optimizaciones
  de ningun tipo, pues casi que da igual.no?}

End;

Begin
  New(Primero);Primero^.Atom:=False;
  InitList;
End.

 {TODO}

.- Pila/lista pascal para trabajo con ficheros de acceso libre de instruccin,
para lectura por partes,etc...

.- Fijado de bugs

.- Ajustar los moviemientos de memoria a cuadruple palabra, segun procesas...,
 Empaquetar en varias versiones segun procesas...

.- Ajustar la Grabacin de tomos en subbloques de 4K de buffer, en lugar
de byte a byte, como esta en la version original.

.- Diversas aceleraciones de secuencias... no estrictamente necesario...

.- Opcionalmente se pueden definir funciones para tratamiento matemtico de
tomos numricos... o incluso versionear toda la libreria...

.- Hacer de la libreria una .DLL y .so para acceso desde cualquier lenguaje
